gitweb: use new Git::Repo API, and add optional caching
[git/gitweb-caching.git] / git-bisect.sh
blob97ac600873ebd0dff6310071343403a41a867b8a
1 #!/bin/sh
3 USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect help
5 print this long help message.
6 git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7 reset bisect state and start bisection.
8 git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10 git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
12 git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
14 git bisect next
15 find next bisection to test and check it out.
16 git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18 git bisect visualize
19 show bisect status in gitk.
20 git bisect replay <logfile>
21 replay bisection log.
22 git bisect log
23 show bisect log.
24 git bisect run <cmd>...
25 use <cmd>... to automatically bisect.
27 Please use "git help bisect" to get the full man page.'
29 OPTIONS_SPEC=
30 . git-sh-setup
31 require_work_tree
33 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
36 sq() {
37 @@PERL@@ -e '
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
42 print "\n";
43 ' "$@"
46 bisect_autostart() {
47 test -s "$GIT_DIR/BISECT_START" || {
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
64 bisect_start() {
66 # Verify HEAD.
68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
73 # Check if we are bisecting.
75 start_head=''
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
93 die "Bad HEAD - strange symbolic ref"
95 esac
99 # Get rid of any old bisect state.
101 bisect_clean_state || exit
104 # Check for one bad and then some good revisions.
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
112 eval=''
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
117 shift
118 break
121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
131 shift
133 esac
134 done
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
147 # Write new start state.
149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
151 eval "$eval" &&
152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
154 # Check if we can proceed to the next bisect state.
156 bisect_auto_next
158 trap '-' 0
161 bisect_write() {
162 state="$1"
163 rev="$2"
164 nolog="$3"
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
170 git update-ref "refs/bisect/$tag" "$rev" || exit
171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
175 bisect_state() {
176 bisect_autostart
177 state=$1
178 case "$#,$state" in
179 0,*)
180 die "Please call 'bisect_state' with at least one argument." ;;
181 1,bad|1,good|1,skip)
182 rev=$(git rev-parse --verify HEAD) ||
183 die "Bad rev input: HEAD"
184 bisect_write "$state" "$rev" ;;
185 2,bad|*,good|*,skip)
186 shift
187 eval=''
188 for rev in "$@"
190 sha=$(git rev-parse --verify "$rev^{commit}") ||
191 die "Bad rev input: $rev"
192 eval="$eval bisect_write '$state' '$sha'; "
193 done
194 eval "$eval" ;;
195 *,bad)
196 die "'git bisect bad' can take only one argument." ;;
198 usage ;;
199 esac
200 bisect_auto_next
203 bisect_next_check() {
204 missing_good= missing_bad=
205 git show-ref -q --verify refs/bisect/bad || missing_bad=t
206 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
208 case "$missing_good,$missing_bad,$1" in
209 ,,*)
210 : have both good and bad - ok
213 # do not have both but not asked to fail - just report.
214 false
216 t,,good)
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
220 if test -t 0
221 then
222 printf >&2 'Are you sure [Y/n]? '
223 read yesno
224 case "$yesno" in [Nn]*) exit 1 ;; esac
226 : bisect without good...
229 THEN=''
230 test -s "$GIT_DIR/BISECT_START" || {
231 echo >&2 'You need to start by "git bisect start".'
232 THEN='then '
234 echo >&2 'You '$THEN'need to give me at least one good' \
235 'and one bad revisions.'
236 echo >&2 '(You can use "git bisect bad" and' \
237 '"git bisect good" for that.)'
238 exit 1 ;;
239 esac
242 bisect_auto_next() {
243 bisect_next_check && bisect_next || :
246 eval_rev_list() {
247 _eval="$1"
249 eval $_eval
250 res=$?
252 if [ $res -ne 0 ]; then
253 echo >&2 "'git rev-list --bisect-vars' failed:"
254 echo >&2 "maybe you mistake good and bad revs?"
255 exit $res
258 return $res
261 filter_skipped() {
262 _eval="$1"
263 _skip="$2"
265 if [ -z "$_skip" ]; then
266 eval_rev_list "$_eval"
267 return
270 # Let's parse the output of:
271 # "git rev-list --bisect-vars --bisect-all ..."
272 eval_rev_list "$_eval" | while read hash line
274 case "$VARS,$FOUND,$TRIED,$hash" in
275 # We display some vars.
276 1,*,*,*) echo "$hash $line" ;;
278 # Split line.
279 ,*,*,---*) ;;
281 # We had nothing to search.
282 ,,,bisect_rev*)
283 echo "bisect_rev="
284 VARS=1
287 # We did not find a good bisect rev.
288 # This should happen only if the "bad"
289 # commit is also a "skip" commit.
290 ,,*,bisect_rev*)
291 echo "bisect_rev=$TRIED"
292 VARS=1
295 # We are searching.
296 ,,*,*)
297 TRIED="${TRIED:+$TRIED|}$hash"
298 case "$_skip" in
299 *$hash*) ;;
301 echo "bisect_rev=$hash"
302 echo "bisect_tried=\"$TRIED\""
303 FOUND=1
305 esac
308 # We have already found a rev to be tested.
309 ,1,*,bisect_rev*) VARS=1 ;;
310 ,1,*,*) ;;
312 # ???
313 *) die "filter_skipped error " \
314 "VARS: '$VARS' " \
315 "FOUND: '$FOUND' " \
316 "TRIED: '$TRIED' " \
317 "hash: '$hash' " \
318 "line: '$line'"
320 esac
321 done
324 exit_if_skipped_commits () {
325 _tried=$1
326 if expr "$_tried" : ".*[|].*" > /dev/null ; then
327 echo "There are only 'skip'ped commit left to test."
328 echo "The first bad commit could be any of:"
329 echo "$_tried" | tr '[|]' '[\012]'
330 echo "We cannot bisect more!"
331 exit 2
335 bisect_next() {
336 case "$#" in 0) ;; *) usage ;; esac
337 bisect_autostart
338 bisect_next_check good
340 skip=$(git for-each-ref --format='%(objectname)' \
341 "refs/bisect/skip-*" | tr '\012' ' ') || exit
343 BISECT_OPT=''
344 test -n "$skip" && BISECT_OPT='--bisect-all'
346 bad=$(git rev-parse --verify refs/bisect/bad) &&
347 good=$(git for-each-ref --format='^%(objectname)' \
348 "refs/bisect/good-*" | tr '\012' ' ') &&
349 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
350 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
351 eval=$(filter_skipped "$eval" "$skip") &&
352 eval "$eval" || exit
354 if [ -z "$bisect_rev" ]; then
355 echo "$bad was both good and bad"
356 exit 1
358 if [ "$bisect_rev" = "$bad" ]; then
359 exit_if_skipped_commits "$bisect_tried"
360 echo "$bisect_rev is first bad commit"
361 git diff-tree --pretty $bisect_rev
362 exit 0
365 # We should exit here only if the "bad"
366 # commit is also a "skip" commit (see above).
367 exit_if_skipped_commits "$bisect_rev"
369 echo "Bisecting: $bisect_nr revisions left to test after this"
370 git checkout -q "$bisect_rev" || exit
371 git show-branch "$bisect_rev"
374 bisect_visualize() {
375 bisect_next_check fail
377 if test $# = 0
378 then
379 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
380 '') set git log ;;
381 set*) set gitk ;;
382 esac
383 else
384 case "$1" in
385 git*|tig) ;;
386 -*) set git log "$@" ;;
387 *) set git "$@" ;;
388 esac
391 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
392 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
395 bisect_reset() {
396 test -s "$GIT_DIR/BISECT_START" || {
397 echo "We are not bisecting."
398 return
400 case "$#" in
401 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
402 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
403 die "$1 does not seem to be a valid branch"
404 branch="$1" ;;
406 usage ;;
407 esac
408 git checkout "$branch" && bisect_clean_state
411 bisect_clean_state() {
412 # There may be some refs packed during bisection.
413 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
414 while read ref hash
416 git update-ref -d $ref $hash || exit
417 done
418 rm -f "$GIT_DIR/BISECT_LOG" &&
419 rm -f "$GIT_DIR/BISECT_NAMES" &&
420 rm -f "$GIT_DIR/BISECT_RUN" &&
421 # Cleanup head-name if it got left by an old version of git-bisect
422 rm -f "$GIT_DIR/head-name" &&
424 rm -f "$GIT_DIR/BISECT_START"
427 bisect_replay () {
428 test -r "$1" || die "cannot read $1 for replaying"
429 bisect_reset
430 while read git bisect command rev
432 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
433 if test "$git" = "git-bisect"; then
434 rev="$command"
435 command="$bisect"
437 case "$command" in
438 start)
439 cmd="bisect_start $rev"
440 eval "$cmd" ;;
441 good|bad|skip)
442 bisect_write "$command" "$rev" ;;
444 die "?? what are you talking about?" ;;
445 esac
446 done <"$1"
447 bisect_auto_next
450 bisect_run () {
451 bisect_next_check fail
453 while true
455 echo "running $@"
456 "$@"
457 res=$?
459 # Check for really bad run error.
460 if [ $res -lt 0 -o $res -ge 128 ]; then
461 echo >&2 "bisect run failed:"
462 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
463 exit $res
466 # Find current state depending on run success or failure.
467 # A special exit code of 125 means cannot test.
468 if [ $res -eq 125 ]; then
469 state='skip'
470 elif [ $res -gt 0 ]; then
471 state='bad'
472 else
473 state='good'
476 # We have to use a subshell because "bisect_state" can exit.
477 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
478 res=$?
480 cat "$GIT_DIR/BISECT_RUN"
482 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
483 > /dev/null; then
484 echo >&2 "bisect run cannot continue any more"
485 exit $res
488 if [ $res -ne 0 ]; then
489 echo >&2 "bisect run failed:"
490 echo >&2 "'bisect_state $state' exited with error code $res"
491 exit $res
494 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
495 echo "bisect run success"
496 exit 0;
499 done
503 case "$#" in
505 usage ;;
507 cmd="$1"
508 shift
509 case "$cmd" in
510 help)
511 git bisect -h ;;
512 start)
513 bisect_start "$@" ;;
514 bad|good|skip)
515 bisect_state "$cmd" "$@" ;;
516 next)
517 # Not sure we want "next" at the UI level anymore.
518 bisect_next "$@" ;;
519 visualize|view)
520 bisect_visualize "$@" ;;
521 reset)
522 bisect_reset "$@" ;;
523 replay)
524 bisect_replay "$@" ;;
525 log)
526 cat "$GIT_DIR/BISECT_LOG" ;;
527 run)
528 bisect_run "$@" ;;
530 usage ;;
531 esac
532 esac